#!/bin/bash

#solo ejecuto el script en centos 5
if [ "$(/bin/rpm -q centos-release)" != "centos-release-5-11.el5.centos" ];then
    exit
fi

mostrarLibres()
{
    local libres=$@
    local count=1
    for i in ${libres[@]}; do
        echo "$count) $i"
        count=$(( count + 1 ))
    done
}
drivers=(i40e ixgbe igb e1000e e1000)
drvlibres=(${drivers[@]})
drvusar=()
while [ ${#drvlibres[@]} -gt 0 ] ; do
    clear
    if [ ${#drvusar[@]} -gt 0 ] ; then
        echo "Orden programado ${drvusar[@]}"
    fi
    mostrarLibres ${drvlibres[@]}
    cant=${#drvlibres[@]}
    read pos
    pos=`echo $pos | sed 's/[^0-9]//g'`
    if  [ "0$pos" -lt "1" ] || [ "0$pos" -gt "$cant" ]; then
        drvlibres=()
    else
        pos=$(( pos - 1 ))
        drvusar[${#drvusar[@]}]=${drvlibres[$pos]}
        drvlibres=(${drvlibres[@]:0:$pos} ${drvlibres[@]:$(($pos + 1))})
    fi

done
clear
echo "Ingrese 1 para confirmar que desea usar el siguiente orden ${drvusar[@]}. Cualquier otra tecla para salir"
read opcion
if [ "$opcion" != "1" ];then
    exit
fi
echo "Borrando alias y drivers viejos"
for i in ${drivers[@]}; do
    sed -i "/alias.*scsi_host.*$i/d" /etc/modprobe.conf
    sed -i "/alias *eth.*$i/d" /etc/modprobe.conf
done
echo "Comentando macs"
sed -i 's/^HWADDR/#HWADDR/g' /etc/sysconfig/network-scripts/ifcfg-eth*
echo "Eliminando /etc/sysconfig/hwconf"
rm -f /etc/sysconfig/hwconf
echo "Comentando macs"
count=0
for i in ${drvusar[@]}; do
    echo "alias scsi_hostadapter_autodrv$count $i" >> /etc/modprobe.conf
    count=$(( count + 1 ))
done
echo "Regenerando initrd"
for i in `find /boot -name 'initrd*el[67]*.img'|sort|grep 'el[67]'|sed 's/^.*initrd-//g;s/.img$//g'`;do
    echo $i
    /sbin/new-kernel-pkg --package kernel --mkinitrd --depmod --install "$i"
done
